push!(LOAD_PATH,"../src/")

using Documenter
#using DocumenterCitations
using BPGates

DocMeta.setdocmeta!(BPGates, :DocTestSetup, :(using QuantumClifford, BPGates); recursive=true)

#bib = CitationBibliography(joinpath(@__DIR__,"src/references.bib"))

makedocs(
#bib,
doctest = false,
clean = true,
warnonly = :missing_docs,
sitename = "BPGates.jl",
format = Documenter.HTML(),
modules = [BPGates],
authors = "Shu Ge, Stefan Krastanov",
pages = [
"BPGates.jl" => "index.md",
"Most Common Gates" => "most_common.md",
"Coincidence Measurements" => "measurements.md",
"Noisy Gates" => "noisy.md",
"API" => "API.md",
]
)

deploydocs(
    repo = "github.com/QuantumSavory/BPGates.jl.git"
)
